{$M 65520, 0, 655360}
program lavirin3;

uses graph, crt;

const
	maxtran = 4;
        maxw = 80; maxh = 25;
	ivica = 30; xst = 10; yst = 10;

type
	mali = -1..1;
        povecanje = record
        	x, y: mali;
        end;

{ Global variables }

var
	tran: array[1..maxtran] of povecanje;
        tabla: array[1..maxw, 1..maxh] of integer;
        startx, starty, ciljx, ciljy, maxi, maxj: integer;
        w: set of 1..maxw;
        h: set of 1..maxh;
        anim: boolean;
        pauza: integer;

{ System-dependant functions }

function itoa(i: longint): string;
var res: string;
begin
	res := '';
	str(i, res);
        itoa := res
end;
{
procedure log(s: string);
var logfile: text;
begin
	assign(logfile, 'lavirint.log');
        $I-
	append(logfile);
        $I+
        if IOResult <> 0 then rewrite(logfile);
	writeln(logfile, s);
        close(logfile)
end;
}
procedure startgraph;
var drajver: string; gd, gm: integer;
begin
	write('BGI drajver se nalazi u [\bp\bgi]: '); readln(drajver);
        if drajver = '' then drajver := '\bp\bgi';
        gd := DETECT;
	initgraph(gd, gm, drajver)
end;

procedure endgraph;
{var ch: char;}
begin
	{ch := readkey;}
        closegraph
end;

procedure line(x, y, x1, y1: integer);
begin
	moveto(x, y); lineto(x1, y1)
end;

procedure poruka(s: string);
var textx1, texty1, textx2, texty2: integer;
	scrsize, msgsize: word;
	screen, message: pointer;
        ch: char;

begin
        textx1 := getmaxx shr 1 - textwidth(s) shr 1;
        texty1 := getmaxy shr 1 - textheight(s) shr 1;
        textx2 := getmaxx shr 1 + textwidth(s) shr 1;
        texty2 := getmaxy shr 1 + textheight(s) shr 1;

	scrsize := imagesize(textx1-17, texty1-17, textx2+17, texty2+17);
        if scrsize = 0 then exit;
	getmem(screen, scrsize);
        getimage(textx1-17, texty1-17, textx2+17, texty2+17, screen^);

        setfillstyle(solidfill, lightgray);
        bar(textx1-15, texty1-15, textx2+15, texty2+15);
        setfillstyle(solidfill, black);
	bar(textx1-5, texty1-5, textx2+5, texty2+5);

        setlinestyle(solidln, 0, 3);
        setcolor(getmaxcolor);
        line(textx1-15, texty1-15, textx2+15, texty1-15);
        line(textx1-15, texty1-15, textx1-15, texty2+15);
        line(textx1-5, texty2+5, textx2+5, texty2+5);
        line(textx2+5, texty1-5, textx2+5, texty2+5);
        setcolor(darkgray);
        line(textx2+15, texty1-15, textx2+15, texty2+15);
        line(textx1-15, texty2+15, textx2+15, texty2+15);
        line(textx1-5, texty1-5, textx2+5, texty1-5);
        line(textx1-5, texty1-5, textx1-5, texty2+5);
        setlinestyle(solidln, 0, 1);

	setcolor(lightgreen);
	outtextxy(textx1, texty1, s);

	msgsize := imagesize(textx1-15, texty1-15, textx2+15, texty2+15);
        if msgsize = 0 then exit;
	getmem(message, msgsize);
        getimage(textx1-15, texty1-15, textx2+15, texty2+15, message^);

        while not keypressed do
        begin
                putimage(textx1-15, texty1-15, message^, normalput);
        	delay(750);
                if not keypressed then begin
			putimage(textx1-17, texty1-17, screen^, normalput);
			delay(250)
                end
        end;
        ch := readkey;
        freemem(screen, scrsize);
        freemem(message, msgsize);
end;

procedure okvir;
const s1 = 'LAVIRINT v3.0'; s2 = 'Copyleft (C) 2000 Strahinja Radic';
begin
	setfillstyle(solidfill, lightgray);
	bar(0, 0, getmaxx, 15);                   {gore}
        bar(0, 15, 25, getmaxy-15);               {levo}
        bar(getmaxx-15, 15, getmaxx, getmaxy-15); {desno}
	bar(0, getmaxy-15, getmaxx, getmaxy);     {dole}

        setlinestyle(solidln, 0, 3);
        setcolor(getmaxcolor);
        line(0, 0, getmaxx, 0); {gore}
	line(0, 0, 0, getmaxy); {levo}
        line(getmaxx-15, 15, getmaxx-15, getmaxy-15); {desno}
	line(25, getmaxy-15, getmaxx-15, getmaxy-15); {dole}
        setcolor(darkgray);
        line(0, getmaxy, getmaxx, getmaxy); {dole}
	line(getmaxx, 0, getmaxx, getmaxy); {desno}
        line(25, 15, getmaxx-15, 15); {gore}
	line(25, 15, 25, getmaxy-15); {levo}
        setlinestyle(solidln, 0, 1);

        settextstyle(defaultfont, horizdir, 1);

        setcolor(black);
        outtextxy(getmaxx shr 1 - textwidth(s1) shr 1+2, 5, s1);
        setcolor(getmaxcolor);
        outtextxy(getmaxx shr 1 - textwidth(s1) shr 1, 3, s1);

        setcolor(black);
        outtextxy(getmaxx shr 1 - textwidth(s2) shr 1+2, getmaxy-10, s2);
        setcolor(getmaxcolor);
        outtextxy(getmaxx shr 1 - textwidth(s2) shr 1, getmaxy-12, s2);
end;

procedure kocka(x, y, boja: integer);
begin
	setfillstyle(solidfill, boja);
        bar(xst+ivica*x, yst+ivica*y, xst+ivica*(x+1), yst+ivica*(y+1));
{        log('bar(' + itoa(xst+ivica*x) + ',' + itoa(yst+ivica*y) + ','
		+ itoa(xst+ivica*(x+1)) + ',' + itoa(yst+ivica*(y+1)) + ');');}
end;

procedure drawstart;
var trougao: array[1..3] of PointType; ix, iy: integer;
begin
	ix := ivica * startx;
        iy := ivica * starty;
	trougao[1].x := xst+ix+2;
	trougao[1].y := yst+iy-8;
	trougao[2].x := xst+ivica*(startx+1)+2;
	trougao[2].y := yst+iy-8;
	trougao[3].x := xst+ix + (xst+ivica*(startx+1))shr 1-(xst+ix)shr 1+2;
	trougao[3].y := yst+iy+2;
	setfillstyle(solidfill, black);
        setcolor(black);
        bar(xst+ix+7, yst+ivica*(starty-1)+2,
		xst+ivica*(startx+1)-3, yst+iy-8);
        fillpoly(3, trougao);
	trougao[1].x := xst+ix;
	trougao[1].y := yst+iy-10;
	trougao[2].x := xst+ivica*(startx+1);
	trougao[2].y := yst+iy-10;
	trougao[3].x := xst+ix + (xst+ivica*(startx+1))shr 1-(xst+ix)shr 1;
	trougao[3].y := yst+iy;
	setfillstyle(solidfill, lightred);
        setcolor(lightred);
        bar(xst+ix+5, yst+ivica*(starty-1),
		xst+ivica*(startx+1)-5, yst+iy-10);
        fillpoly(3, trougao);
end;

procedure drawend;
begin
        setcolor(lightred);
	setlinestyle(solidln, 0, 3);
        moveto(xst+ciljx*ivica, yst+ciljy*ivica);
        lineto(xst+(ciljx+1)*ivica, yst+(ciljy+1)*ivica);
        moveto(xst+(ciljx+1)*ivica, yst+ciljy*ivica);
        lineto(xst+ciljx*ivica, yst+(ciljy+1)*ivica);
        setcolor(getmaxcolor);
	setlinestyle(solidln, 0, 1);
end;

procedure happyface(x, y: integer);
var x1, x2, y1, y2: integer;
begin
	if (x in w) and (y in h) then
        begin
                x1 := xst+ivica*x; x2 := xst+ivica*(x+1);
                y1 := yst+ivica*y; y2 := yst+ivica*(y+1);

                x1 := (x2-x1) shr 1 + x1; y1 := (y2-y1) shr 1 + y1;

                setfillstyle(solidfill, lightblue);
                setcolor(black);
        	pieslice(x1, y1, 0, 360, ivica shr 1);
                setfillstyle(solidfill, getmaxcolor);
        	pieslice(x1-6, y1-4, 0, 360, 6);
                setfillstyle(solidfill, black);
        	pieslice(x1-5, y1-4, 0, 360, 3);
                setfillstyle(solidfill, getmaxcolor);
        	pieslice(x1+6, y1-4, 0, 360, 6);
                setfillstyle(solidfill, black);
        	pieslice(x1+5, y1-4, 0, 360, 3);
                setcolor(black);
                arc(x1, y1, 225, 315, ivica shr 1 - 5);
                if anim then delay(pauza)
        end
end;

procedure sadface(x, y: integer);
var x1, x2, y1, y2: integer;
begin
	if (x in w) and (y in h) then
        begin
                x1 := xst+ivica*x; x2 := xst+ivica*(x+1);
                y1 := yst+ivica*y; y2 := yst+ivica*(y+1);

                x1 := (x2-x1) shr 1 + x1; y1 := (y2-y1) shr 1 + y1;

                setfillstyle(solidfill, lightgreen);
                setcolor(black);
        	pieslice(x1, y1, 0, 360, ivica shr 1);
                setfillstyle(solidfill, getmaxcolor);
        	pieslice(x1-6, y1-4, 0, 360, 6);
                setfillstyle(solidfill, black);
        	pieslice(x1-5, y1-4, 0, 360, 3);
                setfillstyle(solidfill, getmaxcolor);
        	pieslice(x1+6, y1-4, 0, 360, 6);
                setfillstyle(solidfill, black);
        	pieslice(x1+5, y1-4, 0, 360, 3);
                setcolor(black);
                arc(x1, y1+ivica shr 1, 45, 135, ivica shr 1 - 5);
                if anim then delay(pauza)
        end
end;

procedure drawxy(x, y: integer);
begin
	if (x in w) and (y in h) then
        begin
                if tabla[x, y] = -2 then sadface(x, y)         {bivsi put}
                else if tabla[x, y] < 0 then happyface(x, y)         {put}
                else if tabla[x, y] = 0 then kocka(x, y, black)      {hodnik}
                else if tabla[x, y] > 0 then kocka(x, y, lightgray); {zid}
                if anim then delay(pauza)
        end
end;

procedure error(msg: string);
begin
	writeln('lavirint: ', msg);
        halt(1)
end;

{ General functions }

function slobodno(x, y: integer; var x1, y1: integer): boolean;
var ret: boolean; i: integer;
begin
	i := 1; ret := false;
	repeat
        	x1 := x + tran[i].x; y1 := y + tran[i].y;
                if (x1 in w) and (y1 in h) then
                	if tabla[x1, y1] = 0 then
                        	ret := true;
        	i := i + 1
        until (i > maxtran) or ret;
        slobodno := ret;
end;

{ -1 = false    }
{  0 = Nadjeno! }
{  1 = true     }
function probaj(x, y: integer): mali;
var ret: mali; x1, y1, j: integer;
begin
	ret := 1; tabla[x, y] := -1; drawxy(x, y);
        if (x = ciljx) and (y = ciljy) then ret := 0
        else begin
        	j := 1;
        	while (j <= maxtran) and (ret <> 0) do
        	begin
        		if slobodno(x, y, x1, y1) then begin
				ret := probaj(x1, y1)
                        end
                	else if j = maxtran then ret := -1;
                	j := j + 1
        	end
        end;
        if ret = -1 then begin
        	tabla[x, y] := -2; drawxy(x, y)
        end;
        probaj := ret
end;

{ Main program variables }

var
	i, j: integer;
        f: text;
        ch: char;
        fajl: string;

begin
	anim := false;
	w := [1..maxw]; h := [1..maxh];
	tran[1].x :=  0; tran[1].y := -1;
	tran[2].x :=  1; tran[2].y :=  0;
	tran[3].x :=  0; tran[3].y :=  1;
	tran[4].x := -1; tran[4].y :=  0;

        for i := 1 to maxw do
        	for j := 1 to maxh do
                	tabla[i, j] := 0;


        write('Unesite ime fajla [lavirint.dat]: '); readln(fajl);
        if fajl = '' then fajl := 'lavirint.dat';

        assign(f, fajl);
        {$I-}
        reset(f);
        {$I+}
        if IOResult <> 0 then error('Ne mogu da otvorim fajl!');
        readln(f, startx, starty); readln(f, ciljx, ciljy);
	j := 1;
        while not eof(f) and (j in h) do
        begin
        	i := 1;
        	while not eoln(f) and (i in w) do
                begin
        		read(f, tabla[i, j]);
                        i := i + 1
                end;
                readln(f); j := j + 1
        end;
        close(f);

        maxi := i-1; maxj := j-1;
        w := [1..maxi]; h := [1..maxj];

        if ([startx, ciljx] * w <> [startx, ciljx])
		or ([starty, ciljy] * h <> [starty, ciljy])
		or (tabla[startx, starty] <> 0)
		or (tabla[ciljx, ciljy] <> 0) then
        	error('Prekoracenje!');

        write('Unesite pauzu, u msec: '); readln(pauza);

        startgraph;
        for i := 1 to maxi do
        	for j := 1 to maxj do
                	drawxy(i, j);

        drawstart; drawend; okvir;
        tabla[startx, starty] := 1;

        anim := true;
        if probaj(startx, starty) = 0 then poruka(' LAVIRINT JE RESIV! ')
        else poruka(' LAVIRINT NIJE RESIV! ');
        endgraph
end.